﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace UWBGL_XNA_Lib3
{
    class RGraphicsDeviceService : IGraphicsDeviceService
    {
        private GraphicsDevice m_graphicsDevice;

        public event EventHandler DeviceCreated;
        public event EventHandler DeviceDisposing;
        public event EventHandler DeviceReset;
        public event EventHandler DeviceResetting;

        public GraphicsDevice GraphicsDevice
        {
            get { return this.m_graphicsDevice; }
            set { m_graphicsDevice = value; }
        }
    }

    class RGameView : IServiceProvider
    {
        public RGraphicsDeviceService m_graphicsDeviceService;

        public void SetService(RGraphicsDeviceService s)
        {
            m_graphicsDeviceService = s;
        }

        public object GetService(System.Type serviceType)
        {
            return this.m_graphicsDeviceService;
        }
    }

    public class UWB_XNAAudioSupport
    {
        ContentManager mAudioResource;

        public UWB_XNAAudioSupport(GraphicsDevice gd) {
            RGraphicsDeviceService rg = new RGraphicsDeviceService();
            rg.GraphicsDevice = gd;

            RGameView services = new RGameView();
            services.SetService(rg);
            mAudioResource = new ContentManager(services);
            mAudioResource.RootDirectory = "./Content/"; // reference from current working folder.
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="clipName">without the .wav</param>
        public void PlaySound(String clipName)
        { 
            SoundEffect clip = mAudioResource.Load<SoundEffect>(clipName);
            if (null != clip)
                clip.Play();
        }
    }
}
